//
// simplnklst.cpp : Defines the entry point for the console application.
// C++ program is an example of a simple linked list.
// Nineveh used boat inventory example is used again
// Copyright (c) Chris H. Pappas and William H. Murray, 2001
//

#include "stdafx.h"
#include <cstdlib>
#include <iostream>

using namespace std;

struct stboat {
  char sztype[15];
  char szmodel[15];
  char sztitle[20];
  char szcomment[80];
  int iyear;
  long int lmotor_hours;
  float fretail;
  float fwholesale;
  struct stboat *nextboat;
} Nineveh, *firstboat,*currentboat;

void boatlocation(struct stboat *node);
void output_data(struct stboat *boatptr);
int datain(struct stboat *Ninevehptr);

int main(int argc, char* argv[] )
{
  firstboat = new (struct stboat);

  if( firstboat == NULL ) exit(1);

  if( datain(&Nineveh) != 0 ) exit(1);

  *firstboat = Nineveh;
  currentboat = firstboat;

  while( datain(&Nineveh) == 0 ) {
  currentboat->nextboat= new (struct stboat);
  if( currentboat->nextboat == NULL ) return(1);
  currentboat = currentboat->nextboat;
  *currentboat = Nineveh;
  }

  currentboat->nextboat = NULL; // signal end of list

  boatlocation(firstboat);

  return (0);
}


void boatlocation(struct stboat *node)
{
  do{
    output_data(node);
  }while( (node = node->nextboat ) != NULL );
}

void output_data(struct stboat *boatptr)
{
  cout << "\n\n\n";
  cout << "A " << boatptr->iyear << " "
       << boatptr->sztype << boatptr->szmodel << " "
       << "beauty with " << boatptr->lmotor_hours << " "
       << "low miles.\n";
  cout << boatptr->szcomment << ".\n";
  cout << "Grab the deal by asking your Nineveh salesperson for";
  cout << " #" << boatptr->sztitle << " ONLY! $"
       << boatptr->fretail << ".\n";
}

int datain(struct stboat *Ninevehptr)
{
  char newline;

  cout << "\n[Enter new boat information - a Q quits]\n\n";
  cout << "Enter the make of the boat.\n";
  cin >> Ninevehptr->sztype;

  if (*(Ninevehptr->sztype) == 'Q') return(1);

  cout << "Enter the model of the boat.\n";
  cin >> Ninevehptr->szmodel;

  cout << "Enter the title number for the boat.\n";
  cin >> Ninevehptr->sztitle;

  cout << "Enter the model year for the boat.\n";
  cin >> Ninevehptr->iyear;

  cout << "Enter the number of hours on the boat motor.\n";
  cin >> Ninevehptr->lmotor_hours;

  cout << "Enter the retail price of the boat.\n";
  cin >> Ninevehptr->fretail;

  cout << "Enter the wholesale price of the boat.\n";
  cin >> Ninevehptr->fwholesale;

  cout << "Enter a one line comment about the boat.\n";
  cin.get(newline);    // process carriage return
  cin.get(Ninevehptr->szcomment,80,'.');

  cin.get(newline);    // process carriage return

  return(0);
}